<%@include file="functions.jsp" %>
<%
    //World Payments Corp Config
    boolean wpcTestMode = true;
    String wpcEndpoint = "";
    if (wpcTestMode) {
        //TEST MODE ENDPOINT
        wpcEndpoint = "https://securetest.paycec.com/redirect-service";
    } else {
        //LIVE MODE ENDPOINT
        wpcEndpoint = "https://secure.paycec.com/redirect-service";
    }
    //Request token from wpc redirect service
    String requestTokenEndpoint = wpcEndpoint + "/request-token";
    String merchantName = "<your_vendor_name>";                  //Replace it by your vendor user name
    String merchantSecretKey = "<your_vendor_secret_key>";       //Replace it by your vendor secret key
    
    //Build request parameters
    HashMap<String, String> params = new HashMap<>();
    Timestamp timestamp = new Timestamp(System.currentTimeMillis());
    long long_token = timestamp.getTime();
    String token = new Long(long_token).toString();
    params.put("merchantName", merchantName);
    params.put("merchantSecretKey", merchantSecretKey);
    params.put("merchantToken", token);                                             //You can change it by your unique token builder
    params.put("merchantReferenceCode", "Test Payment " + token);                   //Replace it by your description
    params.put("amount", "9.95");                                                   //Replace it by your total amount
    params.put("currencyCode", "USD");                                              //Replace it by your currency code
    params.put("returnUrl", "http://localhost:8080/PayCEC/return.jsp");  //Replace it by your return call back url
    params.put("cancelUrl", "http://localhost:8080/PayCEC/cancel.jsp");  //Replace it by your cancel call back url

    //You can specify up to 10 items, where n is a digit between 0 and 9, inclusive; except for digital goods, which supports only single payments (set n to 0).
    params.put("item_0_amt", "2.05"); //Replace it by your amount of item_1
    params.put("item_0_name", "Product Item 1"); //Replace it by your name of item_1
    params.put("item_0_qty", "1"); //Replace it by your quantity of item_1
    params.put("item_1_amt", "3.95");
    params.put("item_1_name", "Product Item 2");
    params.put("item_1_qty", "2");

    String sig = signature(requestTokenEndpoint, params, merchantSecretKey);
    params.put("sig", sig);
    
    //Call to Secure PayCEC Service to request token
    String json = call_WPC(requestTokenEndpoint, params);
    JSONObject jsonObj = new JSONObject(json);
    Object aObj = jsonObj.get("isSuccessful");
    if ((jsonObj != null) && aObj.equals("true")) {
        //Did request token successfully!
        
        token = jsonObj.getString("token");
        
        //Redirect your buyer to the Secure PayCEC Webscreen to make payment
        String redirectEndpoint = wpcEndpoint + "/webscreen?token=" + token;
        response.sendRedirect(redirectEndpoint);
        
        //After the buyer charged, the Secure PayCEC will redirect to your return callback url
        //If the buyer cancel payment, the Secure PayCEC will redirect to your cancel callback url
    } else {
         //Error handling
        out.print("We've got some errors retrieving from WPC service" + "</br>");
        out.print("- Error Code: " + jsonObj.get("errorCode") + "</br>");
        out.print("- Error Message: " + jsonObj.get("message") + "</br>");
        if (jsonObj.get("errorField") != null) {
            out.print("- Error Field:" + jsonObj.get("errorField") + "</br>");
        }
    }
%>